using System;
using System.Collections.Generic;
using System.Text;

using Tao.OpenGl;

namespace Sketcher
{
    class FitToViewportContainer : Container
    {
        Box2f m_viewport;

        public FitToViewportContainer()
            : base(new VerticalStackingExpanderLayout(new Box2f(0, 0, 1, 1)))
        {
            m_viewport = new Box2f(0, 0, 1, 1);
            ViewportUpdated();
        }


        public void ViewportUpdated() {
            int[] nViewport = new int[4];
            Gl.glGetIntegerv(Gl.GL_VIEWPORT, nViewport);
            m_viewport = new Box2f( (float)nViewport[0], (float)nViewport[1], 
                (float)(nViewport[0]+nViewport[2]), (float)(nViewport[1]+nViewport[3]) );
            Layout.InvalidateLayout();
            Resize(m_viewport);
        }



#region Item Overrides


        override public void Render() {
            ValidateLayout();

            // set clip region for child
            RenderEngine.Get.PushClipBox(ChildAreaBounds);

            for (int i = 0; i < Items.Count; ++i) {
                if (Element.VisibleForRendering(Items[i].Visibility))
                    Items[i].Render();
            }

            RenderEngine.Get.PopClipBox();
        }
#endregion




#region Container Overrides
        override protected Box2f GetChildAreaRegion() {
            return Bounds;
        }
#endregion

    }
}
