using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class VerticalTilingLayout : Layout
    {
        Box2f m_bounds;

        public VerticalTilingLayout() {
            m_bounds = new Box2f(false);
        }

#region  Layout interface

        protected override Box2f ItemBounds {
            get { return m_bounds; }
        }

        protected override void LayoutObjects(Container c) {
            Box2f childbounds = c.ChildAreaBounds;
            float fWidth = childbounds.Width;

            float fPadTEMPTEMPTEMP = 0.0f;

            float fCurX = 0;
            float fRowHeight = 0;
            float fCurY = 0;
            int nRowCount = 0;
            for (int i = 0; i < c.Items.Count; ++i) {
                Box2f itemsize = c.Items[i].Bounds;
                if (fCurX + itemsize.Width > fWidth && nRowCount > 0) {
                    fCurY += fRowHeight + fPadTEMPTEMPTEMP;
                    fCurX = 0;
                    nRowCount = 0;
                    fRowHeight = 0;
                }

                // update item position wrt top of container
                Box2f itemBounds = c.Items[i].Size.ToBox();
//                itemBounds.MoveMin(childbounds.Min.X + fCurX, childbounds.Min.Y + fCurY);
                itemBounds.MoveMin(fCurX, fCurY);
                itemBounds = c.MoveRelativeToTop(itemBounds);

                c.Items[i].Resize(itemBounds);

                fCurX += itemsize.Width + fPadTEMPTEMPTEMP;
                if (itemsize.Height > fRowHeight)
                    fRowHeight = itemsize.Height;
                nRowCount++;

                if (i == 0)
                    m_bounds = c.Items[i].Bounds;
                else
                    m_bounds.Contain(c.Items[i].Bounds);
            }
        }

#endregion

    }
}
