using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class CircleButton : Button
    {
        Circle2f m_circle;

        public CircleButton( float fSize ) : base(fSize, fSize) {
            m_circle = new Circle2f( Vector2f.ZERO, fSize / 2 );

            BackgroundColor = ColorRGBA.WHITE;
            ForegroundColor = ColorRGBA.BLACK;

            Resize(new Box2f(fSize, fSize));
        }

        override public IRegion Geometry {
            get { return m_circle; }
        }

        override public void Resize( Box2f newBounds, Transform relativeTo ) {
            base.Resize( newBounds, relativeTo );
            if (m_circle != null) {
                m_circle.Center = Bounds.Center;
                m_circle.Radius = Bounds.Width/2;
            }
        }


        //! draw object
        override public void Render( ) {
            RenderEngine.Get.DrawCircle( m_circle, AlphaBackgroundColor );

            if (m_bDrawIcon) {
                Icon useIcon = Icons.GetBestIcon( IconSet.IconState_Enabled, Bounds );
                useIcon.Draw( Bounds, Opacity );
            }

            if (m_bDrawBorder)
                RenderEngine.Get.DrawCircleOutline( m_circle, 2.0f, AlphaForegroundColor );
        }

    }
}
