using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher {

    class ToggleButton<T> : Button {

        T m_target;
        Predicate<T> m_isOn;

        ColorRGBA m_vOnHilightColor;

        public ToggleButton(float fWidth, float fHeight, T target, Predicate<T> isOnPredicate )
            : base(fWidth, fHeight) {
            
            m_isOn = isOnPredicate;
            m_target = target;

            BackgroundColor = ColorRGBA.WHITE;
            m_vOnHilightColor = ColorRGBA.LIGHTLIGHTGREY;
        }


        public bool IsOn() {
            return m_isOn(m_target);
        }


        // [TODO] clean this up somehow so we can use base.Render...
        override public void Render() {

            if (IsOn()) {
                ColorRGBA bg = m_vOnHilightColor;
                bg.A *= Opacity;
                RenderEngine.Get.DrawBox(Bounds, bg);
            } else
                RenderEngine.Get.DrawBox(Bounds, AlphaBackgroundColor);

            if (m_bDrawIcon) {
                Icon useIcon = Icons.GetBestIcon(IconSet.IconState_Enabled, Bounds);
                useIcon.Draw(Bounds, Opacity);
            }

            if (m_bDrawBorder)
                RenderEngine.Get.DrawBoxOutline(Bounds, AlphaForegroundColor);
        }
    }
}
