using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class FadeAnimation : Animation
    {
        public enum FadeType {
            FadeIn,
            FadeOut
        };
        FadeType m_eType;

        public FadeAnimation( Renderable target, FadeType eType, float fDuration ) : base(target, fDuration)
        {
            m_eType = eType;
            m_fDuration = fDuration;
        }

        //! animation action
        override protected void OnTimeUpdated() {
            float fTransparency = (m_eType == FadeType.FadeOut) ?
                TimeElapsedFraction : 1.0f - TimeElapsedFraction;
            Target.Opacity = 1 - fTransparency;

            if ( m_eType == FadeType.FadeOut && Target.Opacity == 0.0f )
                Target.Visibility = VisibilityState.Hidden;
            if ( m_eType == FadeType.FadeIn && Target.Opacity == 1.0f )
                Target.Visibility = VisibilityState.Visible;
        }
    }
}
