using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace Sketcher
{
    public class FilePath
    {
        public enum FileLocation
        {
            Disk,
            Resource
        };
        FileLocation m_eLocation;

        string m_sPath;
        string m_sFilename;

        public static readonly FilePath UnknownPath = new FilePath( FileLocation.Disk, "", "" );

        public FilePath( FileLocation location, string sPath, string sFilename ) {
            m_eLocation = location;
            m_sPath = sPath;
            m_sFilename = sFilename;

            // [TODO] ensure proper last character on path...
            if (m_eLocation == FileLocation.Disk && !m_sPath.EndsWith( System.IO.Path.DirectorySeparatorChar.ToString() ))
                m_sPath += System.IO.Path.DirectorySeparatorChar;
        }

        public FilePath( FileLocation location, string sFullPath ) {
            m_eLocation = location;
            if ( m_eLocation == FileLocation.Disk ) {
                m_sPath = System.IO.Path.GetDirectoryName( sFullPath ) + System.IO.Path.DirectorySeparatorChar;
                m_sFilename = System.IO.Path.GetFileName( sFullPath );
            } else
                throw new NotSupportedException("FilePath constructor doesn't know how to parse Resource paths");
        }


        public FileLocation Location {
            get { return m_eLocation; }
        }

        public string Path {
            get { return m_sPath; }
        }

        public string Filename {
            get { return m_sFilename; }
        }

        public string FullName {
            get { return Path + Filename; }
        }

    }
}
