using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class LineStroke
    {
        Stroke m_stroke;
        Vector2f m_vBegin;
        Vector2f m_vEnd;
        Vector2f m_vLine;
        Vector2f m_vDir;
        Box2f m_vBounds;
        float m_fLength;

        public LineStroke(Stroke s) {
            m_stroke = s;
            m_vBegin = s.Vertices[0];
            m_vEnd = s.Vertices[s.Vertices.Count - 1];
            m_vLine = m_vEnd - m_vBegin;
            m_vDir = m_vLine;
            m_fLength = m_vDir.Normalize();
            m_vBounds = new Box2f(m_vBegin, m_vEnd);
        }

        public Vector2f Begin {
            get { return m_vBegin; }
        }
        public Vector2f End {
            get { return m_vEnd; }
        }
        public Box2f Bounds {
            get { return m_vBounds; }
        }

        public Vector2f Line {
            get { return m_vLine; }
        }
        public Vector2f Direction {
            get { return m_vDir; }
        }
        public float Length {
            get { return m_fLength; }
        }

        public Stroke Stroke {
            get { return m_stroke; }
        }
    }
}
