using System;
using System.Collections.Generic;
using System.Text;

namespace Sketcher
{
    class RadialCrossMenu : Widget
    {
        protected Circle2f m_circle;

        public RadialCrossMenu(Element parent, float fRadius) : base(parent) {
            Resize(new Box2f(fRadius, fRadius));
            m_circle = new Circle2f(Vector2f.ZERO, fRadius);

            ForegroundColor = ColorRGBA.WHITE;
            BackgroundColor = ColorRGBA.DARKDARKGREY;

            // default to fade in-out behavior...
            this.Behaviors.Add(new FadeInOutBehavior(this));
        }

        public Vector2f Center {
            get { return Bounds.Center; }
            set {
                Box2f tmp = Bounds;
                tmp.Translate(value - Bounds.Center);
                Resize(tmp); 
            }
        }


        /*
         * Widget Overrides
         */

        override protected void UpdateGeometry() {
            m_circle.Center = Bounds.Center;
        }

        override protected void RenderWidget() {
            RenderEngine.Get.DrawCircle(m_circle, AlphaBackgroundColor);
            RenderEngine.Get.DrawCircle(m_circle.Center, m_circle.Radius-2.0f, AlphaForegroundColor);
        }

    }
}
